Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/ios_dev.m
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/ios_dev.m	(revision 3466)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/ios_dev.m	(revision 3467)
@@ -74,15 +74,15 @@
 struct ios_stream
 {
-    pjmedia_vid_stream	 base;		    /**< Base stream	       */
-    pjmedia_vid_param	 param;		    /**< Settings	       */
-    pj_pool_t           *pool;              /**< Memory pool.          */
-
-    pjmedia_vid_cb       vid_cb;            /**< Stream callback.      */
-    void                *user_data;         /**< Application data.     */
-
-    pjmedia_rect_size	 size;
-    pj_uint8_t		 bpp;
-    unsigned		 bytes_per_row;
-    unsigned		 frame_size;
+    pjmedia_vid_dev_stream  base;		/**< Base stream       */
+    pjmedia_vid_param	    param;		/**< Settings	       */
+    pj_pool_t		   *pool;		/**< Memory pool       */
+
+    pjmedia_vid_cb	    vid_cb;		/**< Stream callback   */
+    void		   *user_data;          /**< Application data  */
+
+    pjmedia_rect_size	    size;
+    pj_uint8_t		    bpp;
+    unsigned		    bytes_per_row;
+    unsigned		    frame_size;
     
     AVCaptureSession		*cap_session;
@@ -110,23 +110,24 @@
 					     unsigned index,
 					     pjmedia_vid_param *param);
-static pj_status_t ios_factory_create_stream(pjmedia_vid_dev_factory *f,
-					     const pjmedia_vid_param *param,
-					     const pjmedia_vid_cb *cb,
-					     void *user_data,
-					     pjmedia_vid_stream **p_vid_strm);
-
-static pj_status_t ios_stream_get_param(pjmedia_vid_stream *strm,
+static pj_status_t ios_factory_create_stream(
+					pjmedia_vid_dev_factory *f,
+					const pjmedia_vid_param *param,
+					const pjmedia_vid_cb *cb,
+					void *user_data,
+					pjmedia_vid_dev_stream **p_vid_strm);
+
+static pj_status_t ios_stream_get_param(pjmedia_vid_dev_stream *strm,
 				        pjmedia_vid_param *param);
-static pj_status_t ios_stream_get_cap(pjmedia_vid_stream *strm,
+static pj_status_t ios_stream_get_cap(pjmedia_vid_dev_stream *strm,
 				      pjmedia_vid_dev_cap cap,
 				      void *value);
-static pj_status_t ios_stream_set_cap(pjmedia_vid_stream *strm,
+static pj_status_t ios_stream_set_cap(pjmedia_vid_dev_stream *strm,
 				      pjmedia_vid_dev_cap cap,
 				      const void *value);
-static pj_status_t ios_stream_start(pjmedia_vid_stream *strm);
-static pj_status_t ios_stream_put_frame(pjmedia_vid_stream *strm,
+static pj_status_t ios_stream_start(pjmedia_vid_dev_stream *strm);
+static pj_status_t ios_stream_put_frame(pjmedia_vid_dev_stream *strm,
 					const pjmedia_frame *frame);
-static pj_status_t ios_stream_stop(pjmedia_vid_stream *strm);
-static pj_status_t ios_stream_destroy(pjmedia_vid_stream *strm);
+static pj_status_t ios_stream_stop(pjmedia_vid_dev_stream *strm);
+static pj_status_t ios_stream_destroy(pjmedia_vid_dev_stream *strm);
 
 /* Operations */
@@ -141,5 +142,5 @@
 };
 
-static pjmedia_vid_stream_op stream_op =
+static pjmedia_vid_dev_stream_op stream_op =
 {
     &ios_stream_get_param,
@@ -294,6 +295,4 @@
     param->flags = PJMEDIA_VID_DEV_CAP_FORMAT;
     param->clock_rate = DEFAULT_CLOCK_RATE;
-    param->frame_rate.num = DEFAULT_FPS;
-    param->frame_rate.denum = 1;
     pj_memcpy(&param->fmt, &di->info.fmt[0], sizeof(param->fmt));
 
@@ -384,9 +383,10 @@
 
 /* API: create stream */
-static pj_status_t ios_factory_create_stream(pjmedia_vid_dev_factory *f,
-					     const pjmedia_vid_param *param,
-					     const pjmedia_vid_cb *cb,
-					     void *user_data,
-					     pjmedia_vid_stream **p_vid_strm)
+static pj_status_t ios_factory_create_stream(
+					pjmedia_vid_dev_factory *f,
+					const pjmedia_vid_param *param,
+					const pjmedia_vid_cb *cb,
+					void *user_data,
+					pjmedia_vid_dev_stream **p_vid_strm)
 {
     struct ios_factory *qf = (struct ios_factory*)f;
@@ -489,5 +489,5 @@
 	
 	if (param->flags & PJMEDIA_VID_DEV_CAP_OUTPUT_WINDOW && param->window)
-	    window = param->window;
+	    window = (UIWindow *)param->window;
 	
 	pj_assert(window);
@@ -522,5 +522,5 @@
     
 on_error:
-    ios_stream_destroy((pjmedia_vid_stream *)strm);
+    ios_stream_destroy((pjmedia_vid_dev_stream *)strm);
     
     return status;
@@ -528,5 +528,5 @@
 
 /* API: Get stream info. */
-static pj_status_t ios_stream_get_param(pjmedia_vid_stream *s,
+static pj_status_t ios_stream_get_param(pjmedia_vid_dev_stream *s,
 				        pjmedia_vid_param *pi)
 {
@@ -547,5 +547,5 @@
 
 /* API: get capability */
-static pj_status_t ios_stream_get_cap(pjmedia_vid_stream *s,
+static pj_status_t ios_stream_get_cap(pjmedia_vid_dev_stream *s,
 				      pjmedia_vid_dev_cap cap,
 				      void *pval)
@@ -567,5 +567,5 @@
 
 /* API: set capability */
-static pj_status_t ios_stream_set_cap(pjmedia_vid_stream *s,
+static pj_status_t ios_stream_set_cap(pjmedia_vid_dev_stream *s,
 				      pjmedia_vid_dev_cap cap,
 				      const void *pval)
@@ -586,5 +586,5 @@
 
 /* API: Start stream. */
-static pj_status_t ios_stream_start(pjmedia_vid_stream *strm)
+static pj_status_t ios_stream_start(pjmedia_vid_dev_stream *strm)
 {
     struct ios_stream *stream = (struct ios_stream*)strm;
@@ -606,5 +606,5 @@
 
 /* API: Put frame from stream */
-static pj_status_t ios_stream_put_frame(pjmedia_vid_stream *strm,
+static pj_status_t ios_stream_put_frame(pjmedia_vid_dev_stream *strm,
 					const pjmedia_frame *frame)
 {
@@ -625,5 +625,5 @@
 
 /* API: Stop stream. */
-static pj_status_t ios_stream_stop(pjmedia_vid_stream *strm)
+static pj_status_t ios_stream_stop(pjmedia_vid_dev_stream *strm)
 {
     struct ios_stream *stream = (struct ios_stream*)strm;
@@ -641,5 +641,5 @@
 
 /* API: Destroy stream. */
-static pj_status_t ios_stream_destroy(pjmedia_vid_stream *strm)
+static pj_status_t ios_stream_destroy(pjmedia_vid_dev_stream *strm)
 {
     struct ios_stream *stream = (struct ios_stream*)strm;
Index: pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/qt_dev.m
===================================================================
--- pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/qt_dev.m	(revision 3466)
+++ pjproject/branches/projects/2.0-dev/pjmedia/src/pjmedia-videodev/qt_dev.m	(revision 3467)
@@ -73,13 +73,13 @@
 struct qt_stream
 {
-    pjmedia_vid_stream	 base;		    /**< Base stream	       */
-    pjmedia_vid_param	 param;		    /**< Settings	       */
-    pj_pool_t           *pool;              /**< Memory pool.          */
-
-    pj_timestamp	 cap_frame_ts;	    /**< Captured frame tstamp */
-    unsigned		 cap_ts_inc;	    /**< Increment	       */
-    
-    pjmedia_vid_cb       vid_cb;            /**< Stream callback.      */
-    void                *user_data;         /**< Application data.     */
+    pjmedia_vid_dev_stream  base;	    /**< Base stream	       */
+    pjmedia_vid_param	    param;	    /**< Settings	       */
+    pj_pool_t		   *pool;           /**< Memory pool.          */
+
+    pj_timestamp	    cap_frame_ts;   /**< Captured frame tstamp */
+    unsigned		    cap_ts_inc;	    /**< Increment	       */
+    
+    pjmedia_vid_cb	    vid_cb;         /**< Stream callback.      */
+    void		   *user_data;      /**< Application data.     */
 
     QTCaptureSession			*cap_session;
@@ -101,21 +101,22 @@
 					    unsigned index,
 					    pjmedia_vid_param *param);
-static pj_status_t qt_factory_create_stream(pjmedia_vid_dev_factory *f,
-					    const pjmedia_vid_param *param,
-					    const pjmedia_vid_cb *cb,
-					    void *user_data,
-					    pjmedia_vid_stream **p_vid_strm);
-
-static pj_status_t qt_stream_get_param(pjmedia_vid_stream *strm,
+static pj_status_t qt_factory_create_stream(
+					pjmedia_vid_dev_factory *f,
+					const pjmedia_vid_param *param,
+					const pjmedia_vid_cb *cb,
+					void *user_data,
+					pjmedia_vid_dev_stream **p_vid_strm);
+
+static pj_status_t qt_stream_get_param(pjmedia_vid_dev_stream *strm,
 				       pjmedia_vid_param *param);
-static pj_status_t qt_stream_get_cap(pjmedia_vid_stream *strm,
+static pj_status_t qt_stream_get_cap(pjmedia_vid_dev_stream *strm,
 				     pjmedia_vid_dev_cap cap,
 				     void *value);
-static pj_status_t qt_stream_set_cap(pjmedia_vid_stream *strm,
+static pj_status_t qt_stream_set_cap(pjmedia_vid_dev_stream *strm,
 				     pjmedia_vid_dev_cap cap,
 				     const void *value);
-static pj_status_t qt_stream_start(pjmedia_vid_stream *strm);
-static pj_status_t qt_stream_stop(pjmedia_vid_stream *strm);
-static pj_status_t qt_stream_destroy(pjmedia_vid_stream *strm);
+static pj_status_t qt_stream_start(pjmedia_vid_dev_stream *strm);
+static pj_status_t qt_stream_stop(pjmedia_vid_dev_stream *strm);
+static pj_status_t qt_stream_destroy(pjmedia_vid_dev_stream *strm);
 
 /* Operations */
@@ -130,5 +131,5 @@
 };
 
-static pjmedia_vid_stream_op stream_op =
+static pjmedia_vid_dev_stream_op stream_op =
 {
     &qt_stream_get_param,
@@ -302,6 +303,4 @@
     param->flags = PJMEDIA_VID_DEV_CAP_FORMAT;
     param->clock_rate = DEFAULT_CLOCK_RATE;
-    param->frame_rate.num = DEFAULT_FPS;
-    param->frame_rate.denum = 1;
     pj_memcpy(&param->fmt, &di->info.fmt[0], sizeof(param->fmt));
 
@@ -348,9 +347,10 @@
 
 /* API: create stream */
-static pj_status_t qt_factory_create_stream(pjmedia_vid_dev_factory *f,
-					    const pjmedia_vid_param *param,
-					    const pjmedia_vid_cb *cb,
-					    void *user_data,
-					    pjmedia_vid_stream **p_vid_strm)
+static pj_status_t qt_factory_create_stream(
+					pjmedia_vid_dev_factory *f,
+					const pjmedia_vid_param *param,
+					const pjmedia_vid_cb *cb,
+					void *user_data,
+					pjmedia_vid_dev_stream **p_vid_strm)
 {
     struct qt_factory *qf = (struct qt_factory*)f;
@@ -445,5 +445,5 @@
 
 	pj_assert(vfd->fps.num);
-	strm->cap_ts_inc = PJMEDIA_SPF2(&strm->param.clock_rate, &vfd->fps, 1);
+	strm->cap_ts_inc = PJMEDIA_SPF2(strm->param.clock_rate, &vfd->fps, 1);
 	
 	[strm->video_output setMinimumVideoFrameInterval:
@@ -470,5 +470,5 @@
     
 on_error:
-    qt_stream_destroy((pjmedia_vid_stream *)strm);
+    qt_stream_destroy((pjmedia_vid_dev_stream *)strm);
     
     return status;
@@ -476,5 +476,5 @@
 
 /* API: Get stream info. */
-static pj_status_t qt_stream_get_param(pjmedia_vid_stream *s,
+static pj_status_t qt_stream_get_param(pjmedia_vid_dev_stream *s,
 				       pjmedia_vid_param *pi)
 {
@@ -495,5 +495,5 @@
 
 /* API: get capability */
-static pj_status_t qt_stream_get_cap(pjmedia_vid_stream *s,
+static pj_status_t qt_stream_get_cap(pjmedia_vid_dev_stream *s,
 				     pjmedia_vid_dev_cap cap,
 				     void *pval)
@@ -515,5 +515,5 @@
 
 /* API: set capability */
-static pj_status_t qt_stream_set_cap(pjmedia_vid_stream *s,
+static pj_status_t qt_stream_set_cap(pjmedia_vid_dev_stream *s,
 				     pjmedia_vid_dev_cap cap,
 				     const void *pval)
@@ -534,5 +534,5 @@
 
 /* API: Start stream. */
-static pj_status_t qt_stream_start(pjmedia_vid_stream *strm)
+static pj_status_t qt_stream_start(pjmedia_vid_dev_stream *strm)
 {
     struct qt_stream *stream = (struct qt_stream*)strm;
@@ -553,5 +553,5 @@
 
 /* API: Stop stream. */
-static pj_status_t qt_stream_stop(pjmedia_vid_stream *strm)
+static pj_status_t qt_stream_stop(pjmedia_vid_dev_stream *strm)
 {
     struct qt_stream *stream = (struct qt_stream*)strm;
@@ -569,5 +569,5 @@
 
 /* API: Destroy stream. */
-static pj_status_t qt_stream_destroy(pjmedia_vid_stream *strm)
+static pj_status_t qt_stream_destroy(pjmedia_vid_dev_stream *strm)
 {
     struct qt_stream *stream = (struct qt_stream*)strm;